// (c) Thomas Kamps, 2009
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the7 implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

#ifndef MONOPDGAME_H
#define MONOPDGAME_H

#include <QList>
#include "monopdfield.h"
#include "monopdtemplate.h"
#include "monopdcard.h"

class MonopdGame : public MonopdTemplate {

	public:
		MonopdGame(QString t, QString n, QString d, int id);
		~MonopdGame();
		MonopdField* getField(int id);
		Player* getPlayer(int id);
		Player* getPlayerFromList(int num);
		bool    hasPlayer(int id);
		MonopdCard* getCard(int id, bool create=true);
		MonopdCard* getCardFromList(int i);
		int     getGameId();
		QString getStatus();
		bool    getCanBeJoined();
		int     getNumPlayer();
		int     getMinPlayer();
		int     getmaxPlayer();
		int     getMaster();
		bool    getCfgAuction();

		int getNumFields();
		int getNumCards();

		void addPlayer(Player* p);
		void removePlayer(Player* p);

		void setGameId(int id);
		void setStatus(QString st);
		void setCanBeJoined(bool cbj);
		void setNumPlayer(int np);
		void setMinPlayer(int mp);
		void setMaxPlayer(int mp);
		void setMaster(int m);

		void setCfgAuction(bool a);

	private:
		QList<MonopdField*> fields;
		QList<Player*> players;
		QList<MonopdCard*> cards;

		int gameId;
		QString status;
		bool canBeJoined;
		int numPlayer;
		int minPlayer;
		int maxPlayer;
		int master;

		bool cfgAuction;

		void addField(MonopdField* f, int p);
};

#endif // MONOPDGAME_H
